/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.file.dao.standard;

import java.util.List;
import java.util.Map;
import java.util.NoSuchElementException;

import jp.terasoluna.fw.file.dao.FileLineException;

/**
 * t@CsIuWFNgpȂt@CǍ@\B
 * <p>
 * eLXgt@C1s̃f[^ǂݎ蕶ƂČďoɕԋpB ̃t@CANZX@\Ƃ͈قȂAt@CsIuWFNggȂB
 * </p>
 * <b>pt@CsIuWFNg̃Ame[V</b><br>
 * @D@{@link jp.terasoluna.fw.file.annotation.FileFormat}̐ݒ荀<br>
 * <div align="center">
 * <table width="90%" border="1" bgcolor="#FFFFFF">
 * <tr>
 * <td><b>_ږ</b></td>
 * <td><b>ږ</b></td>
 * <td><b>ftHgl</b></td>
 * <td><b>K{</b></td>
 * </tr>
 * <tr>
 * <td> <code>s؂蕶</code></td>
 * <td> <code>lineFeedChar</code></td>
 * <td> <code>VXe̍s؂蕶</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>t@CGR[fBO</code></td>
 * <td> <code>fileEncodeing</code></td>
 * <td> <code>VXẽt@CGR[fBO</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>wb_s</code></td>
 * <td> <code>headerLineCount</code></td>
 * <td> <code>0</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>gCs</code></td>
 * <td> <code>trailerLineCount</code></td>
 * <td> <code>0</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * </table>
 * </div> <br>
 * <b>ӎ</b><br>
 * <ul>
 * @
 * <li>؂蕶ƈ͂ݕ̐ݒ͖B</li>
 * </ul>
 */
public class PlainFileLineIterator extends AbstractFileLineIterator<Object> {

    /**
     * ؂蕶B
     */
    private char delimiter = ',';

    /**
     * ͂ݕB
     */
    private char encloseChar = Character.MIN_VALUE;

    /**
     * ݃t@C͏ς݂̃f[^̍sB
     */
    private int currentLineCount = 0;

    /**
     * gCmFptOB
     */
    private boolean readTrailer = false;

    /**
     * RXgN^B
     * @param fileName t@C
     * @param clazz ʃNX
     * @param columnParserMap tH[}bgXg
     */
    @SuppressWarnings("unchecked")
    public PlainFileLineIterator(String fileName, Class clazz,
            Map<String, ColumnParser> columnParserMap) {
        super(fileName, clazz, columnParserMap);

        // sB
        super.init();
    }

    /**
     * 񕪊B
     * <p>
     * f[^̃f[^Pst@CsIuWFNg̃Ame[V̋Lqɏ]JɕB<br>
     * ̃NXł͏͎ĂȂ߁A<code>UnsupportedOperationException</code>X[B
     * </p>
     * @param fileLineString f[^̃f[^Ps
     * @return f[^Ps̕𕪉z
     */
    @Override
    public String[] separateColumns(String fileLineString) {
        throw new UnsupportedOperationException(
                "separateColumns(String) isn't supported.");
    }

    /**
     * JԂŃt@CsIuWFNgԋpB
     * <p>
     * ̍s̃R[h̏t@CsIuWFNgɊi[ĕԋpB<br>
     * </p>
     * @return t@ĈPs̕
     */
    @Override
    public String next() {
        if (readTrailer) {
            throw new FileLineException(
                    "Data part should be called before trailer part.",
                    new IllegalStateException(), getFileName(),
                    currentLineCount);
        }
        if (!hasNext()) {
            throw new FileLineException(
                    "The data which can be acquired doesn't exist.",
                    new NoSuchElementException(), getFileName(),
                    currentLineCount + 1, null, -1);
        }
        currentLineCount++;
        return readLine();
    }

    /**
     * f[^̃f[^ǂݔ΂sB<br>
     * @param skipLines ǂݔ΂sB
     */
    public void skip(int skipLines) {
        for (int i = 0; i < skipLines; i++) {
            if (!hasNext()) {
                throw new FileLineException(
                        "The data which can be acquired doesn't exist.",
                        new NoSuchElementException(), getFileName(),
                        currentLineCount + 1);
            }
            readLine();
            currentLineCount++;
        }
    }

    /**
     * gC̃f[^擾B<br>
     * @return gC̕񃊃Xg
     * @see jp.terasoluna.fw.file.dao.standard.AbstractFileLineIterator#getTrailer()
     */
    @Override
    public List<String> getTrailer() {
        List<String> trailer = super.getTrailer();
        readTrailer = true;
        return trailer;
    }

    /**
     * ؂蕶擾B
     * @return ؂蕶
     */
    @Override
    public char getDelimiter() {
        return delimiter;
    }

    /**
     * ͂ݕ擾B
     * @return ͂ݕ
     */
    @Override
    public char getEncloseChar() {
        return encloseChar;
    }

    /**
     * ݃t@C͏ς݂̃f[^̍s擾B
     * @return ݃t@C͏ς݂̃f[^̍sB
     */
    @Override
    public int getCurrentLineCount() {
        return currentLineCount;
    }

    /**
     * t@CsIuWFNgɃAme[Vݒ肳Ă鎖`FbN邩ǂԂB<br>
     * PlainFileLineIteratorł̓`FbNsȂ߁AfalseB
     * @return false
     */
    @Override
    protected boolean isCheckColumnAnnotationCount() {
        return false;
    }
}
